;*=*=*
;       EHARD/DCT
;       Emulate hard disk in a DOS file under TRS80
;
;       Copyright (c) 1998, Timothy Mann
;
;       This software may be copied, modified, and used for any
;       purpose without fee, provided that (1) the above copyright
;       notice is retained, and (2) modified versions are clearly
;       marked as having been modified, with the modifier's name and
;       the date included.  
;
;       Created 1-10-98
;            modified on Tue Sep 29 13:27:01 PDT 1998 by mann
;       Last modified on 05/19/99 by D. Keil
;       (change name, messages & offset to 4 bytes)
;*=*=*
; Number of drives to allow
NDRIVE  EQU     8       
; ASCII chars
LF      EQU     10
CR      EQU     13
ETX     EQU     3
; Model 4 SVC numbers
@HIGH   EQU     100
@DSPLY  EQU     10
@FLAGS  EQU     101
@LOGOT  EQU     12
@GTDCB  EQU     82 
@GTMOD  EQU     83
@DIV8   EQU     93
@MUL16  EQU     91
@KEYIN  EQU     9
; Model I/III hard addresses
M3FLAG$ EQU     0125H   ; 'I' in ROM on Model III
@LOGOT1 EQU     447BH
@LOGOT3 EQU     428AH
@DSPLY1 EQU     4467H
@DSPLY3 EQU     4467H
HIGH$1  EQU     4049H
HIGH$3  EQU     4411H
CFLAG$1 EQU     4758H
CFLAG$3 EQU     4758H
@ICNFG1 EQU     4303H
@ICNFG3 EQU     421DH
@MULT1  EQU     4B8FH
@MULT3  EQU     444EH
@DIVEA1 EQU     4B7BH
@DIVEA3 EQU     4B7AH
@KEYIN1 EQU     0040H
@KEYIN3 EQU     0040H
; Emulator trap instructions in byte-reversed form
EMT_READ        EQU     32EDH
EMT_WRITE       EQU     33EDH
EMT_LSEEK       EQU     34EDH
EMT_STRERROR    EQU     35EDH
EMT_FTRUNCATE   EQU     3DEDH
EMT_OPENDISK    EQU     3EEDH
EMT_CLOSEDISK   EQU     3FEDH
; Constants for emt_opendisk
EO_RDONLY       EQU    00O
EO_WRONLY       EQU    01O
EO_RDWR         EQU    02O
EO_CREAT        EQU  0100O
EO_EXCL         EQU  0200O
EO_TRUNC        EQU 01000O
EO_APPEND       EQU 02000O
;*=*=*
;       Set origin to be safe on both LDOS 5 and 6
;*=*=*
        ORG     6000H
;*=*=*
;       Relocator for disk driver
;*=*=*
INSTAL: LD      (DCT),DE        ;Save DCT address
        LD      A,(000AH)       ;Determine TRS-80 model
        CP      40H
        JP      NZ,LSDOS6       ;Model 4 (or other LS-DOS, I hope)
        LD      A,(M3FLAG$)
        CP      'I'
        JP      Z,MODEL3        ;Go if Model III
;*=*=*
;       LDOS 5 Model I - See LS-DOS 6 version for comments
;*=*=*
        LD      A,0CDH          ;Insert Model I @LOGOT
        LD      (LOGOT),A
        LD      HL,@LOGOT1
        LD      (LOGOT+1),HL
        LD      (DOMUL),A       ;Insert Model I MULT
        LD      HL,@MULT1
        LD      (DOMUL+1),HL
        LD      (DODIV),A       ;Insert Model I DIVEA
        LD      HL,@DIVEA1
        LD      (DODIV+1),HL
        LD      A,'1'           ;Modify filename
        LD      (HMOD),A
        LD      HL,HELLO_
        CALL    @DSPLY1
        LD      A,(CFLAG$1)
        BIT     3,A             ;System request?
        JP      Z,VIASET
        LD      DE,(DCT)
        LD      A,D             ;DRIVE= must be specified
        OR      E
        JP      Z,NEEDDR
ASKU1:  LD      HL,UNIT_        ;Ask which unit number
        CALL    @DSPLY1
        LD      HL,UNIT
        LD      BC,100H
        CALL    @KEYIN1
        JP      C,HITBRK
        JP      NZ,HITBRK
        LD      A,(UNIT)
        CP      '0'
        JR      C,ASKU1
        CP      '0'+NDRIVE
        JR      NC,ASKU1
        LD      HL,(HIGH$1)
        CALL    XGTMOD          ;Module already loaded?
        JP      Z,SETDCT
        LD      HL,(HIGH$1)
        LD      (NEWEND),HL
        LD      DE,LENGTH
        SUB     A
        SBC     HL,DE
        LD      (HIGH$1),HL
        CALL    DVRINI
        CALL    RELO
        LD      A,(@ICNFG1)
        LD      (LINK),A
        LD      HL,(@ICNFG1+1)
        LD      (LINK+1),HL
        LD      HL,DVRCFG
RX16    EQU     $-2
        LD      (@ICNFG1+1),HL
        LD      A,0C3H
        LD      (@ICNFG1),A
        JP      MOVE
;*=*=*
;       LDOS 5 Model III
;*=*=*
MODEL3:
        LD      A,0CDH          ;Insert Model III @LOGOT
        LD      (LOGOT),A
        LD      HL,@LOGOT3
        LD      (LOGOT+1),HL
        LD      (DOMUL),A       ;Insert Model III MULT
        LD      HL,@MULT3
        LD      (DOMUL+1),HL
        LD      (DODIV),A       ;Insert Model III DIVEA
        LD      HL,@DIVEA3
        LD      (DODIV+1),HL
        LD      A,'3'           ;Modify filename
        LD      (HMOD),A
        LD      HL,HELLO_
        CALL    @DSPLY3
        LD      A,(CFLAG$3)
        BIT     3,A             ;System request?
        JP      Z,VIASET
        LD      DE,(DCT)
        LD      A,D             ;DRIVE= must be specified
        OR      E
        JP      Z,NEEDDR
ASKU3:  LD      HL,UNIT_        ;Ask which unit number
        CALL    @DSPLY3
        LD      HL,UNIT
        LD      BC,100H
        CALL    @KEYIN3
        JP      C,HITBRK
        JP      NZ,HITBRK
        LD      A,(UNIT)
        CP      '0'
        JR      C,ASKU3
        CP      '0'+NDRIVE
        JR      NC,ASKU3
        LD      HL,(HIGH$3)
        CALL    XGTMOD          ;Module already loaded?
        JP      Z,SETDCT
        LD      HL,(HIGH$3)
        LD      (NEWEND),HL
        LD      DE,LENGTH
        SUB     A
        SBC     HL,DE
        LD      (HIGH$3),HL
        CALL    DVRINI
        CALL    RELO
        LD      A,(@ICNFG3)
        LD      (LINK),A
        LD      HL,(@ICNFG3+1)
        LD      (LINK+1),HL
        LD      HL,DVRCFG
RX17    EQU     $-2
        LD      (@ICNFG3+1),HL
        LD      A,0C3H
        LD      (@ICNFG3),A
        JP      MOVE
;*=*=*
;       LS-DOS 6
;*=*=*
LSDOS6: LD      A,'4'           ;Modify filename
        LD      (HMOD),A
        LD      HL,HELLO_
        LD      A,@DSPLY        ;Display hello
        RST     40
;*=*=*
;       Check if entry from SYSTEM command.
;*=*=*
        LD      A,@FLAGS        ;Get flags pointer into IY
        RST     40
        LD      A,(IY+'C'-'A')  ;Get CFLAG$
        BIT     3,A             ;System request?
        JP      Z,VIASET
        LD      DE,(DCT)
        LD      A,D             ;DRIVE= must be specified
        OR      E
        JP      Z,NEEDDR
;*=*=*
;       Ask which unit number
;*=*=*
ASKU4:  LD      HL,UNIT_        ;Ask which unit number
        LD      A,@DSPLY
        RST     40
        LD      HL,UNIT
        LD      BC,100H
        LD      A,@KEYIN
        RST     40
        JP      C,HITBRK
        JP      NZ,HITBRK
        LD      A,(UNIT)
        CP      '0'
        JR      C,ASKU4
        CP      '0'+NDRIVE
        JR      NC,ASKU4
;*=*=*
;       Check if driver already loaded
;*=*=*
        LD      DE,MODNAM
        LD      A,@GTMOD
        RST     40
        JP      Z,SETDCT        ;Already loaded, skip loading
;*=*=*
;       Obtain low memory driver pointer.  Bizarre API here!
;*=*=*
        LD      E,'K'           ;Locate pointer to *KI DCB
        LD      D,'I'           ;  via @GTDCB SVC
        LD      A,@GTDCB        
        RST     40
        JP      NZ,CURDL        ;No error unless KI clobbered!
        DEC     HL              ;Decrement to driver pointer
        LD      D,(HL)          ;P/u hi-order of pointer,
        DEC     HL              ;  decrement to and p/u
        LD      E,(HL)          ;  lo-order of pointer
;*=*=*
;       Check if driver will fit into [(LCPTR), X'12FF']
;*=*=*
        PUSH    HL              ;Save address of pointer
        LD      HL,LENGTH       ;New pointer will be
        ADD     HL,DE           ;  pointer + LENGTH
        LD      D,H             ;Save a copy in DE
        LD      E,L
        LD      BC,1301H        ;If > 1300H, driver won't fit
        SUB     A               ;Reset carry flag
        SBC     HL,BC
        POP     HL              ;Get back address of pointer
        JR      NC,USEHI        ;Go if driver won't fit
        LD      (HL),E          ;Store new value of pointer
        INC     HL
        LD      (HL),D
        DEC     DE              ;Last byte of driver goes here
        LD      (NEWEND),DE
        JR      DORELO
;*=*=*
;       Put in high memory instead.
;*=*=*
USEHI:  LD      HL,0            ;Get current HIGH$
        LD      B,L
        LD      A,@HIGH 
        RST     40
        JP      NZ,NOMEM
        LD      (NEWEND),HL     ;Last byte of driver goes here
        LD      DE,LENGTH
        SUB     A               ;Reset carry flag
        SBC     HL,DE           ;Compute new HIGH$
        LD      A,@HIGH         ;Set new HIGH$ into the system
        RST     40
;*=*=*
;       Relocate internal references in driver.
;       HL = address for last byte of driver.
;*=*=*
DORELO: CALL    DVRINI          ;Final driver init before move
        CALL    RELO
;*=*=*
;       Link to @ICNFG (must follow address relocation and precede movement)
;*=*=*
        LD      A,@FLAGS        ;Get flags pointer into IY
        RST     40
        LD      A,(IY+28)       ;Copy current @ICNFG into LINK
        LD      L,(IY+29)
        LD      H,(IY+30)
        LD      (LINK),A
        LD      (LINK+1),HL
        LD      HL,DVRCFG       ;Get relocated init address
RX10    EQU     $-2
        LD      (IY+29),L       ;Save in @ICNFG vector
        LD      (IY+30),H
        LD      (IY+28),0C3H    ;Insert JP opcode
;*=*=*
;       Move driver into low or high memory.
;*=*=*
MOVE:
        LD      DE,(NEWEND)     ;Destination address
        LD      HL,DVREND       ;Last byte of module
        LD      BC,LENGTH       ;Length of filter
        LDDR
        EX      DE,HL
        INC     HL              ;Bump to driver entry
;*=*=*
;       Setup DCT (iy+5 to iy+9 are reset by ckopen if successful)
;*=*=*
SETDCT:
        LD      IY,(DCT)
        LD      (IY+1),L          ;Driver address
        LD      (IY+2),H
        LD      (IY+3),00001100B  ;Flags: rigid, fixed, step rate 0
        LD      A,(UNIT)
        AND     0FH
        OR      00010000B         ;Flags: alien (=no index pulses), unit#
        LD      (IY+4),A
        LD      (IY+5),0          ;LDOS undefined; we use as sec/cyl (0=256).
        LD      (IY+6),201        ;high cylinder number
        LD      (IY+7),11111111B  ;high head # (111), high sec/trak (11111)
        LD      (IY+8),11111111B  ;high gran # (111), high sec/gran (11111)
        LD      (IY+9),0FFH       ;Directory cylinder
;*=*=*
;       Open file now so user can get error if any, and so geometry
;       is established as early as possible.
;*=*=*
        CALL    CKOPEN
        LD      HL,0            ;Successful completion
        RET     Z               ;Fall thru if error
;*=*=*
UERROR: LD      HL,ERRBUF       ;DOS error
        LD      BC,256
        DEFW    EMT_STRERROR
        DEFB    0DDH
CURDL:  LD      HL,CURDL_       ;Other error
        DEFB    0DDH
NEEDDR: LD      HL,NEEDDR_
        DEFB    0DDH
VIASET: LD      HL,VIASET_
        DEFB    0DDH
NOMEM:  LD      HL,NOMEM_
        DEFB    0DDH
HITBRK: LD      HL,HITBRK_
LOGOT:  LD      A,@LOGOT 
        RST     40
        LD      HL,-1            ;Unuccessful completion
        RET
;*=*=*
;       Relocate internal references in driver.
;       HL = address for last byte of driver.
;*=*=*
RELO:   LD      HL,(NEWEND)
        LD      IY,RELTAB       ;Point to relocation tbl
        LD      DE,DVREND
        SUB     A               ;Clear carry flag
        SBC     HL,DE
        LD      B,H             ;Move to BC
        LD      C,L
RLOOP:  LD      L,(IY)          ;Get address to change
        LD      H,(IY+1)
        LD      A,H
        OR      L
        RET     Z
        LD      E,(HL)          ;P/U address
        INC     HL
        LD      D,(HL)
        EX      DE,HL           ;Offset it
        ADD     HL,BC
        EX      DE,HL
        LD      (HL),D          ;And put back
        DEC     HL
        LD      (HL),E
        INC     IY
        INC     IY
        JR      RLOOP           ;Loop till done
;*=*=*
;       Search for existing copy of driver.
;        Rough Model I/III emulation of Model 4 @GTMOD,
;        hardcoded with driver address.
;       Entry: HL holds HIGH$
;       Exit Z: HL holds driver address
;            NZ: driver not found
;*=*=*
XGTMOD: INC     HL
        LD      A,H
        OR      L
        JR      NZ,XGTM1
        DEC     A               ;not found
        RET
XGTM1:  LD      A,(HL)
        CP      18H             ;unconditional jr?
        RET     NZ              ;not a module header
        PUSH    HL              ;save start address
        INC     HL              ;skip jr
        INC     HL              ;skip offset
        INC     HL              ;skip start address
        INC     HL
        LD      A,(HL)          ;compare name length
        CP      MODPTR-MODNAM
        JR      NZ,NEXTMD       ;different - skip
        LD      B,A             ;compare name
        LD      DE,MODNAM
        INC     HL
XGTM2:  LD      A,(DE)
        CP      (HL)
        JR      NZ,NEXTMD       ;different - skip
        INC     DE
        INC     HL
        DJNZ    XGTM2
        POP     HL              ;same - found
        RET
NEXTMD: POP     HL              ;get back start of module
        INC     HL
        INC     HL
        LD      E,(HL)          ;pointer to last byte
        INC     HL
        LD      D,(HL)
        EX      DE,HL
        JR      XGTMOD
;*=*=*
;       Messages and globals
;*=*=*
HELLO_: DEFB    'EHARD - Emulated hard disk driver for TRS80 - 5/19/99',CR
CURDL_: DEFB    'LS-DOS is curdled!',CR
NOMEM_: DEFB    'High memory is not available!',CR
VIASET_: DEFB    'Must install via SYSTEM (DRIVE=,DRIVER=)!',CR
NEEDDR_: DEFB   'DRIVE= must be specified!',CR
UNIT_:  DEFB    'Enter unit number ([0]-','0'+NDRIVE-1,'): ',ETX
HITBRK_: DEFB   'Aborted!',CR
LCPTR:  DEFW    0
NEWEND: DEFW    0
DCT:    DEFW    0
UNIT:   DEFS    2
ERRBUF: DEFS    256
;
; Driver - Based on skeletal driver from the Guide
;
ENTRY:  JR      BEGIN           ;The driver starts with the
        DEFW    DVREND          ;  DOS standard header
RX00    EQU     $-2
        DEFB    MODPTR-MODNAM   ;Length of name
MODNAM: DEFB    'EHARD'         ;Name for @GTMOD requests
MODPTR: DEFW    0               ;These pointers are unused
        DEFW    0
FD:     DEFS    NDRIVE*2        ;DOS file descriptors
OFFSET: DEFW    0,0,0,0         ;lseek offset buffer
;*=*=*
;       First make sure the file is open and correct the geometry
;       in the DCT if needed.
;*=*=*
BEGIN:  PUSH    IX
        CALL    CKOPEN
RX03    EQU     $-2
        CALL    BODY
RX06    EQU     $-2
        POP     IX
        RET
BODY:   LD      A,32            ;"Illegal drive number"
        RET     NZ
        LD      A,B             ;The first test will return
        AND     A               ;  to the caller on @DCSTAT
        RET     Z               ;  and set the Z-flag with A=0
NOTDCS: CP      7
        JR      Z,RSLCT         ;Transfer on @RSLCT
        JR      NC,DISKIO       ;Transfer on physical I/O request
;*=*=*
;       @SLCT, @DCINIT, @DCRES, @RSTOR, @STEPI or @SEEK: no-op
;*=*=*
RETZER: SUB     A
        RET
;*=*=*
;       The RSLCT function should return with the hardware
;       write protection status. Set bit 6 of the accumulator
;       to indicate the drive is write-protected
;*=*=*
RSLCT:  SUB     A               ;No emulated hardware WP for now
        RET
;*=*=*
DISKIO: BIT     2,B             ;Test if read or write commands
        JR      NZ,WRCMD        ;Transfer if functions <12-15>
        CP      10
        JR      Z,VRSEC
        JR      NC,RDTRK
        CP      9
        JR      Z,RDSEC
RDHDR:  LD      A,32            ;Not supported ("Illegal drive number")
        AND     A            
        RET
;*=*=*
RDSEC:                          ;Read a sector of data
        LD      A,(IY+6)        ;Get high cyl #
        CP      D               ;At or below it?
        JR      NC,RDOK
        LD      A,2             ;"Seek error during read"
        RET                     ;NZ already set
RDOK:   PUSH    DE
        PUSH    HL
        CALL    DOSEEK          ;Setup and do lseek
RX01    EQU     $-2
        POP     HL
        LD      A,5             ;"Data record not found during read"
        JR      NZ,RDDUN
        LD      BC,256
        DEFW    EMT_READ
        LD      A,4             ;"Parity error during read"
RDDUN:  POP     DE
        RET     NZ
        LD      A,B             ;Check for end of file
        OR      C
        JR      NZ,RDDUN2
        PUSH    DE
        PUSH    HL              ;Return a block full of 0E5H            
        PUSH    BC
        LD      (HL),0E5H
        LD      D,H
        LD      E,L
        INC     DE
        LD      BC,0FFH
        LDIR
        POP     BC
        POP     HL
        POP     DE
        SUB     A
        RET
RDDUN2: LD      A,D
        SUB     (IY+9)
        JR      NZ,RDDUN1
        ADD     A,6             ;"Attempted to read system data record"
        RET
RDDUN1: SUB     A
        RET
;*=*=*
VRSEC:                          ;Read/verify -- we don't bother reading
        LD      A,(IY+6)        ;Get high cyl #
        CP      D               ;At or below it?
        JR      NC,RDDUN2       ;Go if so
        LD      A,2             ;"Seek error during read"
        RET                     ;NZ already set
;*=*=*
;       On RDSEC and VRSEC, if the read referenced the
;       directory cylinder and was successful,
;       then you need to return an error code 6. A floppy
;       disk controller will provide the indicated status.
;       Hard disk users may have to compare the requested
;       cylinder to DIRCYL in the DCT.
;*=*=*
RDTRK:  LD      A,32            ;Not supported ("Illegal drive number")
        AND     A            
        RET
;*=*=*
WRCMD:  BIT     7,(IY+3)        ;Check for software write protect
        JR      Z,WRCMD1        ;Transfer if no soft WP
        LD      A,15            ;Set "Write protected disk" error
        RET
WRCMD1: CP      14              ;Now parse functions 12-15
        JR      Z,WRSSC
        JR      NC,WRTRK
        CP      13
        JR      Z,WRSEC
;*=*=*
HDFMT:                          ;Low-level format (=erase)
        LD      (IY+9),0FFH     ;Invalidate directory cylinder
        PUSH    DE
        PUSH    HL
        LD      E,(IX)          ;Get fd
        LD      D,(IX+1)
EXISTS: LD      HL,OFFSET+3             ;Truncate file to just the header
RX07    EQU     $-2
        LD      (HL),00H
        DEC     HL
        LD      (HL),00H
        DEC     HL
        LD      (HL),01H
        DEC     HL
        LD      (HL),00H
        DEFW    EMT_FTRUNCATE
CREATD: POP     HL
        POP     DE
        LD      A,14            ;"Write fault on disk drive"
        RET     NZ
        SUB     A
        RET
;*=*=*
WRSEC:                          ;Write with X'FB' data address mark
        LD      A,(IY+9)        ;Can't do on designated dir cylinder
        CP      D               
        JR      NZ,WROK
BADDAM: LD      A,12            ;"Directory write error" (?)
        AND     A
        RET
;*=*=*
WRSSC:                          ;Write with X'F8' data address mark
        LD      A,(IY+9)        ;Can do only on designated dir cylinder
        CP      D
        JR      NZ,BADDAM
;*=*=*
WROK:   LD      A,(IY+6)        ;Get high cyl #
        CP      D               ;Beyond it?
        JR      NC,WROK1
        LD      A,10            ;"Seek error during write"
        RET                     ;NZ already set
;*=*=*
WROK1:  PUSH    DE
        PUSH    HL
        CALL    DOSEEK
RX04    EQU     $-2
        POP     HL
        LD      A,13            ;"Data record not found during write"
        JR      NZ,WRDUN
        LD      BC,256
        DEFW    EMT_WRITE
        LD      A,12            ;"Parity error during write"
WRDUN:  POP     DE
        RET     NZ
        SUB     A
        RET
;*=*=*
WRTRK:  LD      A,32            ;Write track
        AND     A               ;Not supported ("Illegal drive number")
        RET
;*=*=*
;       Perform lseek before r/w
;*=*=*
DOSEEK: SUB     A               ;sec/cyl to hl, xlate 0 to 256
        LD      H,A
        ADD     A,(IY+5)
        LD      L,A
        JR      NZ,NOINC
        INC     H
NOINC:  LD      C,D             ;cyl# to c
        LD      B,E             ;sec# to b
        LD      A,C             ;model I/III call uses a, not c
DOMUL:  LD      A,@MUL16        ;hla = hl * c, smash de
        RST     40
        LD      D,H             ;sec# to de (h is 0)
        LD      E,B
        LD      H,L             ;product to hl
        LD      L,A
        INC     HL              ;add 1 extra for header
        ADD     HL,DE
        EX      DE,HL           ;offset to de
        LD      HL,OFFSET+3
RX15    EQU     $-2
        LD      (HL),00H
        DEC     HL
        LD      (HL),D
        DEC     HL
        LD      (HL),E
        DEC     HL
        LD      BC,0
        LD      (HL),C
        LD      E,(IX)          ;Get fd
        LD      D,(IX+1)
        DEFW    EMT_LSEEK
        RET
;*=*=*
;       Open file and read geometry if needed, and
;       get address of correct fd to ix.
;*=*=*
CKOPEN: LD      IX,FD           ;Compute fd address
RX02    EQU     $-2
        PUSH    DE
        LD      D,0
        LD      A,(IY+4)
        AND     0FH
        RLCA
        LD      E,A
        ADD     IX,DE
        POP     DE
        LD      A,(IX)          ;fd == -1?
        AND     (IX+1)
        INC     A
        JR      Z,DOOPEN
        SUB     A
        RET
DOOPEN: PUSH    DE
        PUSH    BC
        PUSH    HL
        LD      BC,EO_RDWR      ;Prepare to open
        LD      DE,0666O        ;mode
        LD      HL,HARD_        ;name
RX05    EQU     $-2
        LD      A,(IY+4)
        AND     0FH
        ADD     A,'0'
        LD      (HADR),A
RX09    EQU     $-2
        DEFW    EMT_OPENDISK
        LD      (IX),E  
        LD      (IX+1),D
        JR      NZ,OPNERR
        LD      HL,OFFSET+3     ;Prepare to read geometry
RX13    EQU     $-2
        LD      (HL),00H
        DEC     HL
        LD      (HL),00H
        DEC     HL
        LD      (HL),00H
        DEC     HL
        LD      (HL),28         ;offset to cyl/sec/gran params
        LD      BC,0
        DEFW    EMT_LSEEK
        JR      NZ,OPNERR
        LD      BC,3            ;length
        DEFW    EMT_READ        ;use offset buffer
        JR      NZ,OPNERR
        LD      A,(HL)          ;cyl
        DEC     A
        LD      (IY+6),A        ;max cylinder
        INC     HL
        LD      B,(HL)          ;sec
        LD      (IY+5),B
        INC     HL
        LD      C,(HL)          ;gran
        LD      E,B             ;compute sec/gran
        LD      A,C             ;model I/III call uses a, not c
DODIV:  LD      A,@DIV8         ;a = e / c, e = e % c
        RST     40              ;remainder mbz, but we don't check here
        DEC     A
        DEC     C
        RRC     C
        RRC     C
        RRC     C
        OR      C
        LD      (IY+7),A        ;heads, secs per track
        LD      (IY+8),A        ;grans, secs per gran
        LD      (IY+9),0FFH     ;dircyl unknown
        SUB     A               ;no error
OPNERR: POP     HL
        POP     BC
        POP     DE
        RET
;*=*=*
;       Boot-time initialization
;*=*=*
DVRCFG: LD      DE,-1           ;@ICNFG chains in here
        DEFW    EMT_CLOSEDISK   ;close any files left from before reboot
        CALL    DVRINI
RX11    EQU     $-2     
LINK:   DEFB    'Tim'           ;Replaced by next link in @ICNFG chain
DVRINI: LD      HL,FD
RX12    EQU     $-2
        LD      D,H
        LD      E,L
        INC     DE
        LD      (HL),0FFH
        LD      BC,NDRIVE*2-1
        LDIR
        RET
;*=*=*
;       Disk name: hardM-N for model M (1,3,4), number N (0-7)
;*=*=*
HARD_:  DEFB    'hard'
HMOD:   DEFB    '1-'
HADR:   DEFB    '0',0,0,0,0,0
DVREND  EQU     $-1
LENGTH  EQU     $-ENTRY
RELTAB: DEFW    RX00,RX01,RX02,RX03,RX04,RX05,RX06,RX07,RX09
        DEFW    RX10,RX11,RX12,RX13,RX15,RX16,RX17,0
        END     INSTAL
