/*************************************************************************
*
*       FILENAME: MKROM.C
*
*       Copyright (c) 1990, 1999 by Better Software Co.
*
*       DESCRIPTION:  Make Model 4 ROM image from MODELA/III file
*
*************************************************************************/

// C++ headers

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <errno.h>

// constants

#define Z80_ROM_LEN         0x3800          // length of Z80 ROM
#define FALSE               0
#define TRUE                !FALSE

// prototypes

// global variables

/*************************************************************************
*
* main program
*
*************************************************************************/

int main()

{
    char *ncptr,*cptr;                      // pointers to near char strings
    int A1,A2,A3,A4,DONE;                   // scratch variables
    int FC1=0,FC2=0;                        // open file channels
    char C1[256];                           // scratch string variable
    char C2[512];                           // scratch string variable
    char drive[MAXDRIVE],dir[MAXDIR],file[MAXFILE],ext[MAXEXT];
    char ROM[Z80_ROM_LEN];                  // buffer to create ROM image in
    char TRS80_PATH[MAXPATH];               // filename buffer
    char TRS80_DRIVE[MAXDRIVE];             // default drive for filenames
    char TRS80_DIR[MAXDIR];                 // default dir for filenames
    char ErrorMsg[256];

    ErrorMsg[0]=0;
    fnsplit(_argv[0],TRS80_DRIVE,TRS80_DIR,NULL,NULL);
    fnmerge(TRS80_PATH,TRS80_DRIVE,TRS80_DIR,"MODELA",".III");
    if ((FC1=open(TRS80_PATH,O_RDONLY|O_BINARY))==-1) {
        sprintf(ErrorMsg,"\nSystem was unable to locate MODELA/III to make ROM image. Program terminated\n");
        goto ProgramExit;
    }
    fnmerge(TRS80_PATH,TRS80_DRIVE,TRS80_DIR,"TRS80",".ROM");
    if ((FC2=open(TRS80_PATH,O_WRONLY|O_CREAT|O_TRUNC|O_BINARY,S_IREAD|S_IWRITE))==-1) {
        sprintf(ErrorMsg,"\nSystem was unable to create TRS80.ROM to make ROM image. Program terminated\n");
        goto ProgramExit;
    }
    do {
        if ((read(FC1,C1,2))==2) {
            switch(C1[0]) {
            case 5:
                read(FC1,C2,C1[1]); break;
            case 2:
                read(FC1,C2,C1[1]); break;
            case 1:
                A2=C1[1]-2;
                if (A2<=0) A2+=0x100;
                read(FC1,&A1,2);
                read(FC1,&ROM[A1],A2);
                break;
            default:
                DONE=TRUE; break;
            }
        }
        else DONE=TRUE;
    } while(!DONE);
    ROM[1]=0xAF, ROM[2]=0x32, ROM[3]=0x5B, ROM[4]=0x40;
    write(FC2,ROM,Z80_ROM_LEN);
    sprintf(ErrorMsg,"\nROM image sucessfully built. TRS80.ROM created.");

ProgramExit:

    if (FC1) close(FC1);
    if (FC2) close(FC2);
    printf("\nMKROM v1.00 by David Keil\n"
    "Utility to make ROM image from MODELA/III file.\n"
    "Copyright 1993,98,99 David Keil\n");
    puts(ErrorMsg);
    return 0;
}
